# coding: utf-8

"""
    Control-M Services

    Provides access to BMC Control-M Services  # noqa: E501

    OpenAPI spec version: 9.20.215
    Contact: customer_support@bmc.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from clients.ctm_api_client.configuration import Configuration


class EncryptionMetadata(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {"encryption_type": "str", "fields_to_encrypt": "list[str]"}

    attribute_map = {
        "encryption_type": "encryptionType",
        "fields_to_encrypt": "fieldsToEncrypt",
    }

    def __init__(
        self, encryption_type=None, fields_to_encrypt=None, _configuration=None
    ):  # noqa: E501
        """EncryptionMetadata - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._encryption_type = None
        self._fields_to_encrypt = None
        self.discriminator = None

        if encryption_type is not None:
            self.encryption_type = encryption_type
        if fields_to_encrypt is not None:
            self.fields_to_encrypt = fields_to_encrypt

    @property
    def encryption_type(self):
        """Gets the encryption_type of this EncryptionMetadata.  # noqa: E501

        The type of encryption algorithm to be used to de/encrypt the fields (AES256 or Blowfish)  # noqa: E501

        :return: The encryption_type of this EncryptionMetadata.  # noqa: E501
        :rtype: str
        """
        return self._encryption_type

    @encryption_type.setter
    def encryption_type(self, encryption_type):
        """Sets the encryption_type of this EncryptionMetadata.

        The type of encryption algorithm to be used to de/encrypt the fields (AES256 or Blowfish)  # noqa: E501

        :param encryption_type: The encryption_type of this EncryptionMetadata.  # noqa: E501
        :type: str
        """

        self._encryption_type = encryption_type

    @property
    def fields_to_encrypt(self):
        """Gets the fields_to_encrypt of this EncryptionMetadata.  # noqa: E501

        The list of XML tag names identifying the fields to be de/encrypted in the request XML  # noqa: E501

        :return: The fields_to_encrypt of this EncryptionMetadata.  # noqa: E501
        :rtype: list[str]
        """
        return self._fields_to_encrypt

    @fields_to_encrypt.setter
    def fields_to_encrypt(self, fields_to_encrypt):
        """Sets the fields_to_encrypt of this EncryptionMetadata.

        The list of XML tag names identifying the fields to be de/encrypted in the request XML  # noqa: E501

        :param fields_to_encrypt: The fields_to_encrypt of this EncryptionMetadata.  # noqa: E501
        :type: list[str]
        """

        self._fields_to_encrypt = fields_to_encrypt

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(EncryptionMetadata, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EncryptionMetadata):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, EncryptionMetadata):
            return True

        return self.to_dict() != other.to_dict()
